/* WCOUNT.C - Ein Beispielprogramm fr die Verwendung
   des integrierten Debuggers

   Copyright (c) 1988 Borland International. "All rights reserved."

*/

#include <stdio.h>
#include <string.h>
#include <process.h>
#include <ctype.h>

#define MAXWORDLEN 16         /* maximale Lnge eines Wortes */
#define NUL   ((char)0)       /* Endemarke (Nullzeichen) */
#define SPACE ((char)0x20)    /* Trennzeichen zwischen Wrtern */

char *nextword(char *lineptr)
{
  while (*lineptr==SPACE)   /* Solange der Zeiger auf ein Leerzeichen */
    lineptr++;              /* zeigt, wird er erhht */
  return(lineptr);          /* Ergebnis: Zeiger auf das */
}                           /* nchste "Nicht-Leerzeichen" */

int wordlen(char *wordstart)
{ char *charptr;          /* Arbeitszeiger */

  charptr = wordstart;      /* Arbeitszeiger auf den bergebenen Startwert */
  while (*charptr &         /* Solange das "momentane" Zeichen != NUL */
         *charptr != SPACE)   /* und != SPACE ist: */
    charptr++;                /* Arbeitszeiger auf das nchste Zeichen */
  return(charptr-wordstart);  /* Ergebnis: Wortende - Start = Lnge */
}

/************ Hauptprogramm *****************/
void main(void)
{ FILE  *infile;        /* Eingabedatei  */
  char  linebuf[1024];  /* "momentane Zeile" */
  char  *lineptr;       /* Zeiger auf das erste/nchste Wort in linebuf */
  int     i;            /* fr Schleifen usw. */
  static int wordlens[MAXWORDLEN],   /* speichert die Wortlngen */
         longwords;     /* Fr Wrter > MAXWORDLEN */

  printf("VORSICHT! WCOUNT.C ist ein bungsprogramm fr den\n");
  printf("Debugger von Turbo C. Wenn Sie dieses Programm *nicht*\n");
  printf("von der integrierten Entwicklungsumgebung aus gestartet haben,\n");
  printf("dann drcken Sie bitte jetzt Ctrl-Break - ansonsten hngt sich\n");
  printf("das System auf.\n");
  printf("Informationen finden Sie in Kapitel 4 des Benutzerhandbuchs.\n");

  printf( "Geben Sie den Namen der Textdatei ein (WCOUNT.DAT): ");

  gets(linebuf);    /* linebuf wird hier "mibraucht" */
  if (!strlen(linebuf))   /* nur RETURN gedrckt? */
    strcpy(linebuf, "WCOUNT.DAT");  /* Standardvorgabe einsetzen */

  infile = fopen(linebuf, "r");  /* ffnen der Datei */
  if (!infile)
    { printf( "Fehler beim ffnen von %s\n", linebuf);
      exit(1);
    }

  while (fgets(linebuf, sizeof(linebuf), infile))  /* Lesen einer Zeile */
   { printf("%s",linebuf);                        /* Ausgabe */
      /* Prfung des Pufferendes und Entfernen des abschlieenden \n */
     i = strlen(linebuf);        /* Lnge der Zeile */
     if (linebuf[i-1] != '\n' )  /* Zeilenvorschub als letztes Zeichen? */
       printf( "Beginn einer berlangen Zeile:\n\t%70s\n", linebuf );
      else
       linebuf[i-1] = NUL;   /* O.K. - Zeilenvorschub durch NUL ersetzen */

    lineptr = nextword(linebuf);   /* Ermitteln des ersten Wortanfangs */

    while (*lineptr)
     { i = wordlen(lineptr);   /* Bestimmung der Wortlnge */
       if (i > MAXWORDLEN)     /* grer als MAXWORDLEN? */
         longwords++;          /* ja - wird als "langes Wort" gespeichert */
        else
         ;                     /* sonst den entsprechenden Zhler erhhen */
         wordlens[i]++;
       lineptr += i;           /* Zeiger um die Wortlnge erhhen */

       lineptr = nextword(lineptr); /* gibt es ein weiteres Wort? */
     } /* while (*lineptr) */
   } /* while (fgets...) */

  printf(  "  Lnge  Anzahl\n" );      /* Ausgabe der Wortlngen */
  for ( i=1; i<MAXWORDLEN; i++ )
    printf( "  %5d %5d\n", i, wordlens[i] );
  printf( "berlange Wrter: %5d\n", longwords);

  /* Schlieen der Datei und Programmende */
  fclose(infile);
}
